diff -Nru dpkg-1.14.25a0.mrvn.1/scripts/Dpkg/Source/Package/V3/quilt.pm dpkg-1.14.25a0.mrvn.2/scripts/Dpkg/Source/Package/V3/quilt.pm
--- dpkg-1.14.25a0.mrvn.1/scripts/Dpkg/Source/Package/V3/quilt.pm	2009-02-01 07:19:01.000000000 +0100
+++ dpkg-1.14.25a0.mrvn.2/scripts/Dpkg/Source/Package/V3/quilt.pm	2009-04-27 16:09:04.000000000 +0200
@@ -254,7 +254,19 @@
             open(APPLIED, ">>", $applied) || syserr(_g("cannot write %s"), $applied);
             print APPLIED "$auto_patch\n";
             close(APPLIED);
-        }
+        } else {
+	    # If quilt was used tell it about the new patch
+	    if (-d "$dir/.pc" and not $self->{'options'}{'without_quilt'})
+            {
+	        # Updating the patch with quilt requires some
+	        # trickery: reverse-apply the patch, force pop it with
+	        # quilt, apply it agian with quilt
+                my $patch_obj = Dpkg::Source::Patch->new(filename => $patch);
+                $patch_obj->apply($dir, add_options => ['-R', '-E']);
+                $self->run_quilt($dir, ['pop', '-f'], wait_child => 1, to_file => '/dev/null');
+                $self->run_quilt($dir, ['push'], wait_child => 1, to_file => '/dev/null');
+	    }
+	}
     } else {
         # Remove auto_patch from series
         if ($has_patch) {
